package com.inspur.gzdev.svr;

package ..deTemp.1733793221459;

import com.alibaba.fastjson.JSONObject;
import com.inspur.base.SvrBase;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.TreeMap;
import net.sf.json.JSONObject;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpMethod;
import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.http.HttpEntity;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.springframework.util.DigestUtils;
import sviolet.smcrypto.SmCryptoUtil;

public class SvrHuangShi extends SvrBase {
  public JSONObject getHuangShiHaoPingList(JSONObject param) {
    JSONObject result = new JSONObject();
    try {
      String url = param.getString("url");
      String appId = param.getString("appId");
      String appscert = param.getString("appscert");
      String publicKey = param.getString("publicKey");
      String idNumber = param.getString("idNumber");
      String pageNum = param.getString("pageNum");
      String pageSize = param.getString("pageSize");
      String pf = param.getString("pf");
      String timestamp = "" + System.currentTimeMillis();
      String data = timestamp + appId + appscert;
      String sign = SmCryptoUtil.sm2Encode(data, publicKey);
      Map<String, Object> staticsParam = new HashMap<>();
      staticsParam.put("appId", appId);
      staticsParam.put("sign", sign);
      staticsParam.put("timestamp", timestamp);
      staticsParam.put("certkeyGOV", idNumber);
      staticsParam.put("pageNum", pageNum);
      staticsParam.put("pageSize", pageSize);
      staticsParam.put("pf", pf);
      JSONObject res = JSONObject.parseObject(endPostParts(staticsParam, url));
      System.out.println("res========>>>>" + res);
      result.put("code", "200");
      result.put("data", res);
      return result;
    } catch (Exception e) {
      result.put("state", "300");
      result.put("msg", "查询失败" + e.getMessage());
      return result;
    } 
  }
  
  public static String endPostParts(Map<String, Object> map, String url) {
    CloseableHttpClient httpClient = HttpClients.createDefault();
    HttpPost httpPost = new HttpPost(url);
    try {
      List<NameValuePair> formData = new ArrayList<>();
      if (map != null) {
        Iterator<Map.Entry> iter = map.entrySet().iterator();
        while (iter.hasNext()) {
          Map.Entry entry = iter.next();
          String key = (String)entry.getKey();
          String value = (String)entry.getValue();
          formData.add(new BasicNameValuePair(key, value));
        } 
      } 
      httpPost.setEntity((HttpEntity)new UrlEncodedFormEntity(formData));
      CloseableHttpResponse response = httpClient.execute((HttpUriRequest)httpPost);
      HttpEntity entity = response.getEntity();
      if (entity != null) {
        String result = EntityUtils.toString(entity);
        System.out.println(result);
        return result;
      } 
      response.close();
      httpClient.close();
    } catch (IOException e) {
      return e.getMessage();
    } 
    return null;
  }
  
  public JSONObject getSvr(JSONObject args) {
    JSONObject result = new JSONObject();
    result.put("code", "300");
    try {
      String url = args.getString("url") + "?" + getQueryUrl(args);
      System.out.println("请求地址： " + url);
      HttpClient httpClient = new HttpClient();
      PostMethod postMethod = new PostMethod(url);
      postMethod.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
      NameValuePair[] data = { new NameValuePair("zjhm", args.getString("zjhm")), new NameValuePair("grzh", args.getString("grzh")), new NameValuePair("xm", args.getString("xm")), new NameValuePair("current", args.getString("current")), new NameValuePair("size", args.getString("size")) };
      postMethod.setRequestBody(data);
      httpClient.executeMethod((HttpMethod)postMethod);
      String res = postMethod.getResponseBodyAsString();
      result.put("data", res);
      result.put("code", "200");
      result.put("msg", "Success");
    } catch (Throwable e) {
      e.printStackTrace();
      result.put("msg", e.getMessage());
    } 
    return result;
  }
  
  public static String getQueryUrl(JSONObject param) {
    Map<String, String> sorted = new TreeMap<>();
    sorted.put("AccessKey", param.getString("AppKey"));
    sorted.put("SecretKey", param.getString("AppSecret"));
    sorted.put("timestamp", String.valueOf(System.currentTimeMillis()));
    Random random = new Random();
    sorted.put("nonce", String.valueOf(random.nextInt()));
    sorted.put("sign", getSign(sorted));
    sorted.remove("SecretKey");
    StringBuilder builder = new StringBuilder();
    sorted.forEach((k, v) -> {
          try {
            builder.append(k).append("=").append(URLEncoder.encode(v, "utf-8")).append("&");
          } catch (UnsupportedEncodingException e) {
            System.out.println("对参数进行重新编码时出错。");
          } 
        });
    builder.deleteCharAt(builder.length() - 1);
    return builder.toString();
  }
  
  public static String getSign(Map<String, String> params) {
    Map<String, String> sorted = new TreeMap<>();
    params.forEach((k, v) -> (String)sorted.put(k, v));
    StringBuilder builder = new StringBuilder();
    sorted.forEach((k, v) -> builder.append(k).append("=").append(v).append("&"));
    String value = builder.toString();
    value = value.substring(0, value.length() - 1);
    return DigestUtils.md5DigestAsHex(value.getBytes()).toUpperCase();
  }
}
